<template>
  <gpa-notification :notification-id="notification.id"
                    :created-at="notification.createdAt"
                    :archived-at="notification.archivedAt"
                    :map-id="notification.mapId"
                    :map-name="notification.mapName"
                    icon="chat">
    <template #title>
      <!-- i18n-tasks-use t('js.notifications.messages.new_comment') -->
      <i18n-t keypath="js.notifications.messages.new_comment">
        <template #username>
          <strong>{{ notification.sender.username }}</strong>
        </template>
        <template #subject_link>
          <router-link :to="{ query: {...$route.query, ...link.query}} ">{{ link.text }}</router-link>
        </template>
      </i18n-t>
    </template>
    <blockquote v-if="notification.content">{{ notification.content }}</blockquote>
  </gpa-notification>
</template>

<script>
import GpaNotification from './_Notification.vue'

import Notification from '../../../../classes/models/Notification'

export default {
  name: 'GpaCommentNotification',
  components: { GpaNotification },
  props: {
    notification: { required: true, type: [Notification, Object] },
  },
  computed: {
    link () {
      switch (this.notification.subject.subject_type) {
        case 'Observation':
          return {
            text: this.$t('js.notifications.messages.an_observation'),
            query: { show_observation: this.notification.subject.subject_id },
          }
        case 'Task':
          return {
            text: this.$t('js.notifications.messages.a_task'),
            query: { show_task: this.notification.subject.subject_id },
          }
        default:
          return { text: this.$t('js.notifications.messages.unhandled_notification_type'), query: {} }
      }
    },
  },
}
</script>
